import java.awt.*;
import java.util.Arrays;

public class ExtensionArmoredClass {
    private static final String _separatorForObject = ":";

    public static  DrawingArmoredCar CreateDrawingArmoredCar(String info) {
        String[] strs = info.split(_separatorForObject);
        if (strs.length == 6)
        {
            var armoredCar = new DrawingArmoredCar(Integer.parseInt(strs[0]), Integer.parseInt(strs[1]), Color.decode(strs[2]));
            armoredCar.drawingCaterpillar = CreateIDrawingCaterpillar(String.join(_separatorForObject, Arrays.copyOfRange(strs, 3, strs.length)));
            return armoredCar;
        }
        if (strs.length == 9)
        {
            var armoredCar = new DrawingTank(Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]), Color.decode(strs[2]),
                    Color.decode(strs[3]), Boolean.parseBoolean((strs[4])),
                    Boolean.parseBoolean(strs[5]));
            armoredCar.drawingCaterpillar = CreateIDrawingCaterpillar(String.join(_separatorForObject, Arrays.copyOfRange(strs, 6, strs.length)));
            return armoredCar;
        }
        return null;
    }

    public static IDrawingCaterpillar CreateIDrawingCaterpillar(String info) {
        String[] strs = info.split(_separatorForObject);
        IDrawingCaterpillar caterpillar = null;
        switch (strs[0]) {
            case "DrawingCaterpillar" -> {
                caterpillar = new DrawingCaterpillar(Color.decode(strs[1]));
                caterpillar.setNumRinks(Integer.parseInt(strs[2]));
            }
            case "DrawingCrossCaterpillar" -> {
                caterpillar = new DrawingCrossCaterpillar(Color.decode(strs[1]));
                caterpillar.setNumRinks(Integer.parseInt(strs[2]));
            }
            case "DrawingDoubleCaterpillar" -> {
                caterpillar = new DrawingDoubleCaterpillar((Color.decode(strs[1])));
                caterpillar.setNumRinks(Integer.parseInt(strs[2]));
            }
        }
        return caterpillar;
    }

    public static String GetDataForSave(DrawingArmoredCar drawingArmoredCar)
    {
        var armoredCar = drawingArmoredCar.armoredCar;
        var str = String.format("%d%s%d%s%d", armoredCar.getSpeed(), _separatorForObject,
                (int)armoredCar.getWeight(), _separatorForObject, armoredCar.getBodyColor().getRGB());
        if (!(armoredCar instanceof EntityTank tank))
        {
            return String.format("%s%s%s", str, _separatorForObject, GetDataForSave(drawingArmoredCar.drawingCaterpillar));
        }
        return String.format("%s%s%d%s%s%s%s%s%s", str, _separatorForObject,
                tank.getDopColor().getRGB(), _separatorForObject, tank.isTowerWeapon(), _separatorForObject,
                tank.isAMachineGun(), _separatorForObject, GetDataForSave(drawingArmoredCar.drawingCaterpillar));
    }

    public static String GetDataForSave(IDrawingCaterpillar drawingCaterpillar) {
        return String.format("%s%s%d%s%d", drawingCaterpillar.getClass().getName(), _separatorForObject,
                drawingCaterpillar.getColor().getRGB(), _separatorForObject, drawingCaterpillar.getNumRinks().val());
    }


}
